%define __os_install_post %{nil}
%define modname fop2

Summary: FOP2
Vendor: asternic.biz
Name: %{modname}
Version: 2
Release: %{_release}
License: Commercial
Group: Applications/System
Source0: %{modname}.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
#BuildArch: %{_arch}
Packager: Nicolas Gudino <nicolas@issabel.com>
URL: http://www.fop2.com
Requires(pre): issabel-pbx >= 4.0.0-1

%description
This package contains the Flash Operator Panel 2 for Asterisk based PBX

%prep
%setup -n %{modname}

%install
rm -rf $RPM_BUILD_ROOT

# Files provided by all Issabel modules
mkdir -p                     $RPM_BUILD_ROOT/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
mkdir -p                     $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p                     $RPM_BUILD_ROOT/etc/sysconfig
mkdir -p                     $RPM_BUILD_ROOT/usr/local
mkdir -p                     $RPM_BUILD_ROOT/usr/share/doc
mkdir -p                     $RPM_BUILD_ROOT/var/www/html
mkdir -p                     $RPM_BUILD_ROOT/var/www/html/modules

mv modules/fop2              $RPM_BUILD_ROOT/var/www/html
#mv modules/fop2manager       $RPM_BUILD_ROOT/var/www/html/modules

mv setup/etc/rc.d/init.d/*   $RPM_BUILD_ROOT/etc/rc.d/init.d
mv setup/etc/sysconfig/*     $RPM_BUILD_ROOT/etc/sysconfig

mv setup/usr/local/fop2      $RPM_BUILD_ROOT/usr/local
mv setup/usr/share/doc/fop2  $RPM_BUILD_ROOT/usr/share/doc

if [ %{_arch} == "x86_64" ] ; then
    mv setup/fop2_server/64/fop2_server $RPM_BUILD_ROOT/usr/local/fop2
    rm -f setup/fop2_server/32/fop2_server
    rm -f setup/fop2_server/aarch64/fop2_server
elif [ %{_arch} == "aarch64" ] ; then
    mv setup/fop2_server/aarch64/fop2_server $RPM_BUILD_ROOT/usr/local/fop2
    rm -f setup/fop2_server/32/fop2_server
    rm -f setup/fop2_server/64/fop2_server
else
    mv setup/fop2_server/32/fop2_server $RPM_BUILD_ROOT/usr/local/fop2
    rm -f setup/fop2_server/64/fop2_server
    rm -f setup/fop2_server/aarch64/fop2_server
fi

mv setup/   $RPM_BUILD_ROOT/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
mv menufop2.xml $RPM_BUILD_ROOT/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/

%pre
if [ -f /usr/local/fop2/fop2.lic ]; then 
if [ -f /etc/sysconfig/fop2 ]; then 
NIC=`grep -o '\-i [^ "]*' /etc/sysconfig/fop2 || true`; 
fi
if [ -f /usr/local/fop2/fop2_server ]; then 
/usr/local/fop2/fop2_server --reactivate | grep EXPIRED
if [ $? -eq 0 ]; then
echo "You must purchase the annual maintenance fee in order to upgrade your";
echo "version ( http://www.fop2.com/buy.php ).";
echo
echo "Or you can keep running the version you have installed now.";
echo
exit 1
fi
fi
fi

mkdir -p /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
touch /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/preversion_%{modname}.info
if [ $1 -eq 2 ]; then
    rpm -q --queryformat='%{VERSION}-%{RELEASE}' %{name} > /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/preversion_%{modname}.info
fi

%post
pathModule="/usr/share/issabel/module_installer/%{name}-%{version}-%{release}"

# Run installer script to fix up ACLs and add module to Elastix menus.
issabel-menumerge /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/menufop2.xml

preversion=`cat $pathModule/preversion_%{modname}.info`

chgrp asterisk /usr/local/fop2
chmod g+rwxs /usr/local/fop2

if [ $1 -eq 1 ]; then #install
    chkconfig --add fop2
    /usr/local/fop2/generate_override_contexts.pl -w
    /usr/local/fop2/create_fop2_manager_user.pl -fff=/usr/local/fop2/fop2.cfg
    service fop2 start
  # Removing fop menu
    echo "Delete fop menu"
    issabel-menuremove "fop"
  # The installer database
    #issabel-dbprocess "install" "$pathModule/setup/db"
  # installing fop2 on freePBX
    #php -q /var/www/html/admin/modules/fop2admin/rpminst.php install
elif [ $1 -eq 2 ]; then #update
    echo "Update fop2"
    if [ -f /etc/asterisk/fop2/fop2.cfg ]; then
        mv /etc/asterisk/fop2/fop2.cfg /usr/local/fop2
    fi
    sed -i "s/-c \/etc\/asterisk\/fop2//g" /etc/sysconfig/fop2
    /usr/local/fop2/fop2_server --reactivate 
    /usr/local/fop2/create_fop2_manager_user.pl -fff=/usr/local/fop2/fop2.cfg
    service fop2 restart
    #issabel-dbprocess "update"  "$pathModule/setup/db" "$preversion"
    # updating fop2 on freePBX
    #php -q /var/www/html/admin/modules/fop2admin/rpminst.php install
fi

# The installer script expects to be in /tmp/new_module
mkdir -p /tmp/new_module/%{modname}
cp -r /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/* /tmp/new_module/%{modname}/
chown -R asterisk.asterisk /tmp/new_module/%{modname}

rm -rf /tmp/new_module

%clean
rm -rf $RPM_BUILD_ROOT

%preun
pathModule="/usr/share/issabel/module_installer/%{name}-%{version}-%{release}"
if [ $1 -eq 0 ] ; then # Validation for desinstall this rpm
  service fop2 stop
  chkconfig --del fop2
  grep -v extensions_override_fop2 /etc/asterisk/extensions_override_issabel.conf > /tmp/ext_override.temp && mv -f /tmp/ext_override.temp /etc/asterisk/extensions_override_issabel.conf

  echo "Delete FOP2 menus"
  issabel-menuremove "%{modname}"

  #echo "Restoring FOP"
  #issabel-menumerge /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/menufop.xml

  #echo "Dump and delete %{name} databases"
  #issabel-dbprocess "delete" "$pathModule/setup/db"
fi

%files
%defattr(-,asterisk,asterisk)
#%{_localstatedir}/www/html/*
/usr/share/issabel/module_installer/*
/var/www/html/fop2
#/var/www/html/modules/fop2manager

%defattr(644,asterisk,asterisk)
/usr/local/fop2/FOP2Callbacks.pm 
/usr/local/fop2/buttons_custom.cfg.sample
/usr/local/fop2/autobuttons.cfg
/usr/local/fop2/generate_override_contexts.pl
/usr/local/fop2/create_fop2_manager_user.pl
/usr/local/fop2/astcli
/usr/local/fop2/setSSL.sh

%attr(751, asterisk, asterisk) /usr/local/fop2/autoconfig-buttons.sh
%attr(751, asterisk, asterisk) /usr/local/fop2/autoconfig-users.sh
%attr(751, asterisk, asterisk) /usr/local/fop2/generate_override_contexts.pl
%attr(751, asterisk, asterisk) /usr/local/fop2/create_fop2_manager_user.pl
%attr(751, asterisk, asterisk) /usr/local/fop2/fop2_server
%attr(751, asterisk, asterisk) /usr/local/fop2/recording_fop2.pl
%attr(751, asterisk, asterisk) /usr/local/fop2/recording_cdr.pl
%attr(751, asterisk, asterisk) /usr/local/fop2/recording_issabel.pl
%attr(751, asterisk, asterisk) /usr/local/fop2/autofill-groups.sh
%attr(751, asterisk, asterisk) /usr/local/fop2/tovoicemail.pl
%attr(751, asterisk, asterisk) /usr/local/fop2/astcli
%attr(751, asterisk, asterisk) /usr/local/fop2/setSSL.sh

%defattr(644,root,root)
/usr/share/doc/fop2/README
/usr/share/doc/fop2/LICENSE

%defattr(644,asterisk,asterisk)
%config /usr/local/fop2/fop2.cfg
%config /etc/sysconfig/fop2

%defattr(-,root,root)
/etc/rc.d/init.d/fop2
/etc/sysconfig/fop2

%changelog
